# lecture 10
# ============================================================
## about homework

pvalues = numeric()

for (i in 1:1000){
	tdata1 = rnorm(100) 
    tdata2 = rnorm(100)
	out = t.test(tdata1, tdata2)
	pvalues = c(pvalues, out$p.value)
}

hist(pvalues)
mean(pvalues<.05)
sum(pvalues < .05) / length(pvalues)


# ============================================================
setwd('/Users/gdutilh/Dropbox/teaching/R/RHS2016/lecture_10')

# Replicate lecture_target_plot.pdf
load('../lecture_9/materials_lecture9/lecture9_data.Rdata')
# For that figure, I changed the range of racism, so let's do that first:
range(d$racism)
d$racism = d$racism + 10

plot(x = d$IQ, y = d$racism, col = d$condition, cex = d$age/20)
## now, I make it all a bit nicer
# I don't like the default axes
# I want axes lables that make sense
# I like axes lables to be bold italics (font.lab = 4)
# I want to change the axes' limits
plot(d$IQ, d$racism, col= d$condition, cex = d$age/20, 
     xlab = "participants' IQ", ylab = 'racism', 
     ylim = c(-8, max(d$racism)), 
     xlim = c(50, 140), 
     font.lab = 4, # to make axis labels bold italic
     axes = FALSE) # to suppress axes
# Now, add the axis myself
axis(1, at = c(60, 100, 140), # where?
     labels = c('low (60)', 'average (100)', 'high (140)')) # what?
axis(2, las = 1) # las = 2 makes lables horizontal


# axes are a bit too loose now, let's add a "box"
box(bty = 'l') # or better with bty = 'l' (box type L)


## add a legend (or actually two)
legend('bottomleft', col = 1:3, pch = 1, 
       legend = c('clean', 'normal', 'messy'), title = 'Condition',
       bty = 'n', cex = 2)

legend('bottomright', pch = 1,  legend = c(20, 30, 40), 
       pt.cex = c(20, 30, 40)/20, bty = 'n', title = 'Age', cex = 2)

title('Racism\nas a Function of\nIQ and condition')

# ============================================================
## graphical parameters
# par

?par

par()# opens a graphic device and returns the current settings

par(cex = 3) # opens a graphic device
plot(1:10)

par(cex.lab = 3)
plot(1:10)


par(cex.lab = 3, font.lab = 4)
plot(1:10)

par(cex.lab = 1)
plot(3:1)

par(mar = c(10, 16, 4, 2))
plot(1:10)

par(cex.lab = 3, font.lab = 4, mar = c(5, 6, 2, 2)) 
plot(1:10)
par(col = 2) # changes the default color of existing device
points(2:6, col = 'green')

# ============================================================
## layout: panelplots

layoutm = matrix(1:6, 3, 2)
layoutm
layout(layoutm)

for(i in 1:6){
  hist(rnorm(100), main = paste('plot', i))
}

layoutm = matrix(1:6, 3, 2)
layout(layoutm, widths = c(3, 1), heights = c(2, 1, 1))


for(i in 1:6){
  hist(rnorm(100), main = paste('plot', i), cex.main = 3)
}

justthree = matrix(1:3, 1, 3)
layout(justthree)
plot(1:3)

layoutm = matrix(c(1, 2, 3, 1, 4, 5), 3, 2)

layout(layoutm)

for(i in 1:5){
  hist(rnorm(100), main = paste('plot', i))
}

layoutm = matrix(c(1, 6, 2, 3, 4, 5), 3, 2) 
 ## watch the 6th placeholder which is never filled
layout(layoutm, widths = c(3, 1), heights = c(2, 1, 1))
par(mar = c(1, 2, 1, 1))
for(i in 1:5){
  plot(0, xlim = c(-1, 1), ylim = c(-1, 1), type = 'n', 
       xlab = '', ylab = '')
  box()
  text(0, 0, labels = paste('plot', i), cex = 3)
}

plot(0, xlim = c(-1, 1), ylim = c(-1, 1), type = 'n', 
       xlab = '', ylab = '', axes = FALSE)
text(0, 0, labels = 'these figures\nshow something')

# order is up to you
layoutm = matrix(6:1, 3, 2)
layoutm
layout(layoutm)
for(i in 1:6){
	#Sys.sleep(.5)
	plot(1:3, main = i, cex.main = 3)}
# ============================================================
## combining par and layout

par(las = 1, bg = 'grey', col.lab = 3, cex.lab = 2.5)
layoutm = matrix(1:6, 3, 2)
layout(layoutm)

for(i in 1:5){
  hist(rnorm(100), main = paste('plot', i))
}

par(mar = c(8, 8, 5, 5)) # extra par-options can be added 
                         # when adevice is openend
plot(1:10, col.lab = 2) ## par is overruled within a figure

# ============================================================
## Saving figures
# You can always select the figure pane and click save as. 
# However, that's not convenient in the long run. Consider
# that you need to plot a figure for each participant.
# Then, you'd rather use a loop and save figures 
# automatically.

?Devices

setwd('/Users/gdutilh/Dropbox/teaching/R/RHS2015/lecture_13')

dir.create('figures')
# open it:
pdf(file = 'figures/just_a_pdf2.pdf', width = 5, height = 3) 
plot(1:10) # fill it
dev.off() # close it to save it


## opened pdf is also a device, so par and layout change
# the settings of the open pdf.
pdf(file = 'figures/that_panelplot.pdf', 
    width = 6, height = 8)
par(las = 2, bg = 'grey', col.lab = 3)
layoutm = matrix(1:6, 3, 2)
layout(layoutm)
for(i in 1:5){
  hist(rnorm(100), main = paste('plot', i))
}
dev.off() # close it to save it

## often, scientific journals want postscript files

postscript('figures/a_postscript_figure.ps', 
           height = 4, width = 4)
n = 1000
hist(runif(n), 10)
abline(h = n/10)
dev.off() # close it to save it

## the good thing of saving files in this way, 
## is that you can do it genericaly:
n = 6666
paste('figures/histunif', n, '.eps', sep = '')


for (n in c(20, 200, 2000, 20000, 200000)){
  postscript(paste('figures/histunif', n, '.eps', sep = ''), 
             height = 4, width = 4)
  hist(runif(n), breaks = 10, main = paste('n = ', n))
  abline(h = n/10)
  dev.off() # close it to save it
}

